;###############################{  VHF  }####################################

; 05/10/92
; * cambios en el manejo del Patch. No debe desactivarse la RPT fuera de modo Yaesu. Ademas en cualquier modo mantiene a PB1=1
; Version       1.02    ; apaga rpt luego de id automatico y apaga rpt luego de anti-poncho/ y state25 arranca en 0
; Escrito por Alejandro Bonello (o al menos intentado)
; ***************************************************************************
; ---------------- Programa de control del 6809 para repetidora -------------
; ***************************************************************************
;                         UNIVERSAL REPEATER CONTROLER

RAM             EQU     $0000
MEM             EQU     $1000
EPROM           EQU     $E300           ; $F000
TABLAS          EQU     $E000
			
FIN_RAM         EQU     $07FF
STACK_U         EQU     $05FF


;---------------< definicion de areas >--------------------------------------

		ORG     RAM

ADC_STATE       RMB     1       ; esdado del conversor A/D
PATCH           RMB     1       ; indica si el patch esta activado o no (sirve para que cuando esta activado no funcione el Anti-Poncho ni se desactive la RPT, etc)
OFS_TABLA       RMB     2       ; variable de uso general utilizada para guardar addresses de memoria de 16 bits
VAR_0           RMB     1       ; variable de uso general 
VAR_1           RMB     1       ; que pensas que puede ser NABO? (idem var_0)
INT_CHANGE      RMB     1       ; sirve para saber cuando cambia de estado el clock de 100Hz
SUMNO           RMB     3       ; se almacena aqui un numero de 6 cifras a sumar o restar
RESULTADO       RMB     3       ; se almacena el resultado de una suma o resta
BUFFER          RMB     1       ; variable utilizada por TIME_OUT para comprovar si la rpt cambio de estado (ej: TX/RX)
STATE_RPT       RMB     1       ; variable utilizada por TIME_OUT para indicarle a el resto del programa el estado de la rpt. esto es: 1 = TX/ 0 = QAP
WAIT_TIME       RMB     4       ; se utiliza para irlo decrementando cada 10ms y hacer una rutina de espera (lo utiliza WAIT e _IRQ)
PRESSED_KEY     RMB    16       ; se almacena lo leido desde el teclado por TECLADO
ABORT_MODE      RMB     1       ; aqui se almacena si el abort fue producido por un "*" o por un "#". esto se logra: ABORT=$0B (para "*") y ABORT=$0C (para "#"). en caso de trabajo normal en esta variable puede haber cualquier otro caracter sin problema.
STATE_00        RMB     1       ; en las variables STATE se almacena la informacion de las distintas funciones del uP (van de STATE_00 a STATE_99)
STATE_01        RMB     1
STATE_02        RMB     1
STATE_03        RMB     1
STATE_04        RMB    16
STATE_05        RMB     1
STATE_06        RMB     1
STATE_07        RMB     1
STATE_08        RMB     1
STATE_09        RMB     1
STATE_10        RMB     2
STATE_11        RMB     1
STATE_12        RMB     1
STATE_13        RMB     2
STATE_14        RMB     2
STATE_15        RMB     1
STATE_16        RMB     1       ; se almacena el password de acceso al DTMF ID
STATE_20        RMB     1
STATE_21        RMB     1       ; se almacena el password de acceso al S-Meter Teller
STATE_22        RMB     2       ; se almacena el tiempo del Squelch Tail
STATE_24        RMB     1       ; se almacena el tipo de rpt. 1 = Yaesu line of Rpt.'s/0 = Full Rpt. COR
STATE_25        RMB     1       ; 1 = Instant Mode on/0 = Instant Mode off
STATE_26        RMB     2       ; Instant Mode PTT max. time
STATE_27        RMB     2       ; Instant Mode PTT min. time
STATE_28        RMB     1       ; 1 = Instant Mode ID enable/0 = Instant Mode S Teller enable
STATE_98        RMB    16       ; se almacena el password de acceso al patch
STATE_99        RMB    16       ; se almacena el password de acceso al sistema
STATE_99_BIS    RMB    16       ; se almacena momentariamente el codigo de acceso (usado por rutina SUB_99/98 para validar el codigo, y en caso de haber un error, el uP deja el viejo codigo)

;----------------------------------------------------------------------------
;---------------< definicion de tablas y constantes >------------------------
;----------------------------------------------------------------------------

		ORG     TABLAS
TABLA_SUB
	FCB     $04,$05,$06,$07,$08,$09
CLEAN_TEC
	FCB     $00,$00,$00,$00
	FCB     $00,$00,$00,$00
	FCB     $00,$00,$00,$00
	FCB     $00,$00,$00,$00
INITIAL_PASSWORD
	FCB     $01,$02,$03,$04,$05,$0C,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
AUTOPATCH_PASSWORD
	FCB     $01,$02,$01,$0A,$0C,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
PAGER_PASSWORD
	FCB     $01,$01,$01,$0C,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
CONV_DTMF_HEX
	FCB     $DD,$11,$22,$33,$44,$55,$66,$77,$88,$99,$00,$00,$00,$AA,$BB,$CC

;****************************************************************************
;                    DEFINICIONES PARA EL PRECOMPILADOR
;****************************************************************************

;***************************** DIRECCIONES **********************************

PIA_0           EQU     $400C
PIA_1           EQU     $400D
PIA_2           EQU     $400E
PIA_3           EQU     $400F

ADC_ADRS        EQU     $4000
DTMF_ADRS       EQU     $2000

AUDIO           EQU     $8000
FIN_AUDIO       EQU     $DFFF

AUD1_ID         EQU     $8000
AUD2_ID         EQU     $9F37           ; 8 segs

AUD1_METER      EQU     $9F38
AUD2_METER      EQU     $AED3           ; 4 segs

AUD1_S1         EQU     $AED3
AUD2_S1         EQU     $B2B9
AUD2_S2         EQU     $B6A0
AUD2_S3         EQU     $BA87
AUD2_S4         EQU     $BE6E
AUD2_S5         EQU     $C255
AUD2_S6         EQU     $C63C
AUD2_S7         EQU     $CA33
AUD2_S8         EQU     $CE0A
AUD2_S9         EQU     $D1F0

AUD1_PONCHO     EQU     $D1F0
AUD2_PONCHO     EQU     $DFFF           ; 3,5 segs aprox.

;************************* MASCARA INTERRUPCIONES ***************************
;el CC del 6809 :        -F-I----       see activa la mascara en '1'

ENABLE_IRQ      EQU     %11101111       ;habilita IRQ. (and)
ENMASK_IRQ      EQU     %00010000       ;enmascara IRQ (or)
ENAB_IRQ_FIRQ   EQU     %10101111
ENMASK_FIRQ     EQU     %01000000
ENAB_FIRQ       EQU     %10111111


;****************************************************************************

;----------------------------------------------------------------------------
;----------------------< vectores de interrupcion >--------------------------
;----------------------------------------------------------------------------

;en orden de prioridad :

VEC_RESET       EQU     $FFFE           ; RESET request
VEC_IRQ         EQU     $FFF8           ; IRQ request

		ORG     VEC_RESET
		FDB     _RESET

		ORG     VEC_IRQ
		FDB     _IRQ
		
;****************************************************************************
;                       INICIALIZACION DEL HARDWARE
;                       (comienzo del programa)
;****************************************************************************
		ORG     EPROM
_RESET

	;---------------- inicializacion del STACK y variables --------------

	LDS     #FIN_RAM

	LDU     #STACK_U

	;----------------- inicializacion de la PIA 6821 --------------------

	
	CLR     PIA_1           ;limpio el control register A
	CLR     PIA_3           ;limpio el control register B

	LDA     #%01011111      
	STA     PIA_0           ;seteo el port A como output, menos PA5 y PA7 
	
	LDA     #%11111111
	STA     PIA_2           ;seteo el port B como output

	LDA     #%00010101      ;seteo el control register A mas la interrupcion del clock de 100Hz, mas CA1 (el bit 1=1) que es la entrada del COR.
	STA     PIA_1

	LDA     #%00000100      ;seteo el control register B
	STA     PIA_3
	
	;a partir de aca la PIA_0 es la direccion del portA
	;                la PIA_2 es la direccion del portB

	; ---------------- SETEA LA INTERRUPCION DE CB2 (PTT) --------------

	LDA     #%00001100      ; pongo bit3 en 1 para activar el CB2 como interrupt input, active on rising edge
	STA     PIA_3
	LDA     PIA_2

	; ---------------- SETEA LA INTERRUPCION DE CB1 (DTMF) -------------

	LDA     PIA_3
	ORA     #%00000010      ; pongo bit1 en 1 y bit0 en 0. queda el IRQ desactivado y el flag sube y baja con la entrada de CB1
	STA     PIA_3
	LDA     PIA_2
	; ---------------- INICIALIZO VALORES DE VARIABLES (si se pide) ----

	LDA     PIA_0
	ORA     #%01000000      ; desabilito momentaneamente rpt.
	STA     PIA_0

	ANDCC   #ENABLE_IRQ
	LDA     #$00
	STA     PRESSED_KEY
	
	LDX     #0500
	STX     WAIT_TIME

	LDA     PIA_1
	ORA     #%00011100      ;seteo el control register A
	STA     PIA_1

	LDA     PIA_3
	ORA     #%00000011      ; hago que el cic9203 llame a interrupcion _IRQ
	STA     PIA_3
	LDA     PIA_2
WAIT_BOOT        
	LDA     PRESSED_KEY     ; no necesito ir a DTMF1_TECLADO, por que al ejecutarce un _IRQ, en el cual esta mandando datos el cic9203, la rutina los introduce en PRESSED_KEY.
	CMPA    #$0E
	BEQ     FULL_RESET      ; si al encender sosengo oprimido la key B, entonces me inicializa nuevamente el equipo
	
	LDD     #$0000
	CMPD    WAIT_TIME
	BNE     WAIT_BOOT
	LBRA    NO_FULL_RESET

FULL_RESET      ; aqui viene cuando realiza un BOOT-UP, pedido por SUB_23, por ejemplo        
	LDX     #INITIAL_PASSWORD
	LDY     #STATE_99
	LDB     #16
	JSR     STRINGCOPY      ; codigo de acceso
	
	LDX     #AUTOPATCH_PASSWORD
	LDY     #STATE_98
	LDB     #16
	JSR     STRINGCOPY      ; codigo del AUTOPATCH

	LDX     #PAGER_PASSWORD
	LDY     #STATE_04
	LDB     #16
	JSR     STRINGCOPY      ; codigo del PAGER
	
	LDA     #$08
	STA     STATE_16        ; codigo de acceso default al DTMF ID
	
	LDA     #$03
	STA     STATE_21        ; codigo de acceso default al S-Meter Teller 

	LDD     #$4650          ; timpo entre ID's con rpt. QAP, es de 3 min (18000 clocks)
	STD     STATE_13

	LDD     #$2904          ; tiempo entre ID's al activar rpt, es de 1,25 min (10500 clocks)
	STD     STATE_14
	
	LDD     #$3A98          ; tiempo de anti-poncho (2,5 min/15000 clocks)
	STD     STATE_10

	LDD     #0100
	STD     STATE_22        ; tiempo de Squelch Tail

	LDD     #0050
	STD     STATE_26        ; tiempo max. del PTT de Instant Mode
	
	LDD     #0003
	STD     STATE_27        ; tiempo min. del PTT de Instant Mode
	
	LDA     #$01
	STA     STATE_00
	STA     STATE_05
	STA     STATE_09        
	STA     STATE_11
	STA     STATE_12
	STA     STATE_15
	STA     STATE_20
	STA     STATE_24        

	LDA     #$00
	STA     STATE_01
	STA     STATE_02
	STA     STATE_03
	STA     STATE_06
	STA     STATE_07
	STA     STATE_08
	STA     STATE_28
	STA     STATE_25
	
NO_FULL_RESET
	LDA     PIA_3
	ANDA    #%11111110      ; hago que el cic9203 no llame a interrupcion _IRQ
	STA     PIA_3
	LDA     PIA_2
	
	LDA     #$00
	STA     PATCH
	;----------------- FIN DE INICIALIZACIONES --------------------------
	
	LDA     #$02
	STA     BUFFER          ; para resetear el timer que este activado (ID o Anti-Poncho), esto se realiza al ir a TIME_OUT
	
	LDD     STATE_13
	STD     WAIT_TIME
	JSR     SAY_ID
START        
	LDA     PIA_1
	ORA     #%00011100      ;seteo el control register A
	STA     PIA_1
	
	JSR     CHANGE_PIA
	JSR     PASS_SEL
DO
	LDA     PIA_1
	ANDA    #%11110111      ;seteo el control register A, (para que no funcione el time_out, esto es CA2 desactivada 100Hz)
	STA     PIA_1
	
	LDA     PIA_0
	ORA     #%01000000      
	STA     PIA_0           ; desactivo momentariamente a la RPT, luego CHANGE_PIA me lo reactiva (o no) al ir a START (quedo claro no?)

	LDB     #02
	JSR     DTMF_TECLADO    ; le pido que me lea 2 bytes del cic9203
	LDA     ABORT_MODE
	CMPA    #$0B
	BEQ     START
	CMPA    #$0C
	BEQ     DO              ; checkeo los distintos tipos de abort's 
	
	JSR     SUB_00
;        JSR     SUB_01
;        JSR     SUB_02
	JSR     SUB_03
	JSR     SUB_04
	JSR     SUB_05
	JSR     SUB_06
	JSR     SUB_07
	JSR     SUB_08
	JSR     SUB_09
	JSR     SUB_10
	JSR     SUB_11
	JSR     SUB_12
	JSR     SUB_13
	JSR     SUB_14
	JSR     SUB_15
	JSR     SUB_16
	JSR     SUB_17
	JSR     SUB_18
	JSR     SUB_19
	JSR     SUB_20
	JSR     SUB_21
	JSR     SUB_22
	JSR     SUB_23
	JSR     SUB_24
	JSR     SUB_25
	JSR     SUB_26
	JSR     SUB_27
	JSR     SUB_28
	JSR     SUB_98
	JSR     SUB_99
	
	LDA     ABORT_MODE
	CMPA    #$0B
	LBEQ    START           ; si como resultado a alguna de las sub's se le entra una tecla de abort, entonces el sistema sale del "loop do"
	LBRA    DO

; ***************************************************************************

; ----- Subrutinas ----------------------------------------------------------

; ***************************************************************************
; RUTINA PARA MANEJO DEL TECLADO + MANEJO DE TECLAS RETENIDAS.        
; DTMF_TECLADO()
; el resultado de la lectura se almacena en PRESSED_KEY, este puede ser entre
; $00 y $0F
; no se requiere pasar ningun tipo de parametros.
; en "B" debe ir la cantidad de caracteres que se quieren leer.
; si lo leido del cic9203 es = $0B o es = $0C, entonces quiere decir que el 
; usuario oprimio "*" o "#" respectivamente, y por lo tanto debe abortar.
; si esperando una lectura del DTMF, se llega a producir un disable de la 
; rpt. (PA7=0), sale de la rutina poniendo a ABORT_MODE en $0B y PRESSED_KEY 
; en $0B.
; ***************************************************************************
DTMF_TECLADO        
	PSHS    A,B,X,Y
				; aqui se acumula la cantidad de caracteres leidos
	LDY     #PRESSED_KEY    ; limpio el lugar donde debe ir el string de PRESSED_KEY
	LDX     #CLEAN_TEC
	JSR     STRINGCOPY
	EXG     X,Y             ; dejo en "X" el address de PRESSED_KEY, para luego irlo incrementando
DIGIT_LOOP
	LDA     PIA_3
	STA     VAR_1           ; lo realizo, para que _IRQ pueda forzar una lectura de DTMF en el caso de que este en modo pager, y haya parado la reproducion
	JSR     TIME_OUT        ; llamo a la rutina, para que checkee si se debe activar el anti-poncho
	
	PSHS    B
	LDB     PIA_0
	ANDB    #$80
	CMPB    #$80
	PULS    B
	BNE     SALIR           ; si esperando la lectura del DTMF se llega a producir un disable de la rpt. (PA7=0), sale de la rutina poniendo a ABORT_MODE en $0B y PRESSED_KEY en $0B
	
	LDA     VAR_1
	ANDA    #$80
	CMPA    #$80
	BNE     DIGIT_LOOP      ; checkeo si viene la interrupcion correcta (la del cic9203 obiamente, que mierda puedo estar esperando!!!)
	
	LDA     PIA_2           ; reseteo el irq de la pia mediante una lectura de la misma.
	LDA     DTMF_ADRS
	ANDA    #$0F            ; solo tomo los 4 bits que utiliza el CIC9203 (por si las moscas)
	STA     ,X        
	LEAX    1,X        
	
	STA     ABORT_MODE      ; guardo el ultimo digito (que en caso de abort es el digio del tipo de abort, para que luego se sepa se volver a DO o a START)
	CMPA    #$0B            ; "*"
	BEQ     END_DTMF
	CMPA    #$0C            ; "#"
	BEQ     END_DTMF        ; si el usuario oprime alguna de las dos teclas de abort "*" o "#", ejecuta el abort
	
	DECB        
	CMPB    #$00
	BNE     DIGIT_LOOP      ; si llego a 0 "B", entonces me voy (ya que se supone que leyo la canidad de bytes que debia, en teoria!!!)
END_DTMF
	PULS    A,B,X,Y        
	RTS     ; -------------------------------- RTS ----------------------
SALIR           
	LDA     #$0B
	STA     PRESSED_KEY
	STA     ABORT_MODE
	BRA     END_DTMF
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA PARA COPIAR UN STRING.
; STRINGCOPY()
; X es el puntero del string a leer, Y es el puntero del lugar de escritura
; y B es la contidad de bytes a copiar.
; ***************************************************************************
STRINGCOPY
	PSHS    A,B,X,Y
	STB     VAR_0
	LDB     #$00
STRC
	INCB
	LDA     ,X
	STA     ,Y
	LEAX    1,X
	LEAY    1,Y
	CMPB    VAR_0
	BNE     STRC
	
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE INTERRUPCIONES.
; _IRQ()
; * maneja el contador de 100Hz que va incrementando a WAIT_TIME
; finalmente no importa el tipo de interrupcion se lee PIA_0 y PIA_2
; ***************************************************************************
_IRQ        
	LDB     PIA_3
	ANDB    #$80
	CMPB    #$80
	BEQ     DTMF_IRQ
	
	LDA     PIA_1
	ANDA    #$40
	CMPA    #$40
	BEQ     WAIT_ON
	BRA     END_IRQ
	
WAIT_ON
	LDD     WAIT_TIME
	CMPD    #$0000
	BEQ     END_IRQ         ; si es cero no le sigo restando, ya que daria la vuelta.

	SUBD    #01
	STD     WAIT_TIME
	BRA     END_IRQ

DTMF_IRQ
	LDA     PIA_2
	ANDA    #$02
	CMPA    #$00
	BEQ     READ_ON         ; si no estaba reproduciendo audio, entonces es por que me llaman del BOOT (principio del programa), de lo contrario estoy reproduciendo audio, en modo pager, y la rpt. estaba desactivada. debo interrumpir la reproduccion.
	
	LDA     PIA_0
	ANDA    #$80
	CMPA    #$80
	BNE     END_IRQ         ; si la rpt. no es peteteada, aunque entre un DTMF no le doy bola

	STX     OFS_TABLA       ; lo realizo para interrumpir la repro.
	LDA     #$80
	STA     VAR_1           ; lo realizo para que PASS_PAGER me lea este digito del DTMF que acaba de interrumpir la repro.
	BRA     END_IRQ
READ_ON        
	JSR     DTMF1_TECLADO
	BRA     END_IRQ

	; ------------------------ TIPOS DE SALIDAS ------------------------
END_IRQ
	LDA     PIA_0
	LDA     PIA_2
	RTI
	; end ---------------------------------------------------------------        
	
; ***************************************************************************
; RUTINA QUE LEE EL CIC9203 (SIN PARAR LA EJECUCION DEL uP)
; DTMF1_TECLADO()
; esta rutina lee la tecla actualmente oprimida, y lo pone en PRESSED_KEY.
; si no hay ninguna tecla oprimida, limpia los 16 char's de PRESSED_KEY, y 
; sale de la rutina.
; si en medio de una lectura de DTMF, se llega a producir un disable de la 
; rpt. (PA7=0), sale de la rutina poniendo a PRESSED_KEY en $0B.
; ***************************************************************************
DTMF1_TECLADO        
	PSHS    A,B,X
	LDA     #$00            ; aqui se pone la tecla oprimida        
	LDB     PIA_0
	ANDB    #%00100000
	CMPB    #%00100000
	BNE     END_DT_RE

	LDA     PIA_2           ; reseteo el irq de la pia
	LDA     DTMF_ADRS
	ANDA    #$0F            ; solo tomo los 4 bits que utiliza el CIC9203 (por si las moscas)
	
	LDB     PIA_0
	ANDB    #$80
	CMPB    #$80
	BEQ     END_DT_RE
	LDA     #$0B
END_DT_RE
	STA     PRESSED_KEY

	PULS    A,B,X
	RTS
	; end ---------------------------------------------------------------        


; ***************************************************************************
; CHECKEA A QUE CODIGO DE ACCESO EL USUARIO QUIERE ACCEDER.
; PASS_SEL()
; no requiere ningun parametro externo. compara el codigo entrado, con los 
; prefijos de cada codigo, que se dan a continuacion.
	* "A" + codigo de AutoPatch                             (------------) se utiliza la ayuda de PASS_PATCH
	* "C" + codigo de accesso al sistema de control         (PASS_CONTROL)
	* "" + codigo para ID de rpt.                           (SAY_ID)
	* "" + codigo para S-Meter Teller de rpt.               (S_TELLER)
; si esta en modo PAGER, entonces primero ejecuta la rutina PASS_PAGER, y 
; luego lo mencionado arriba.
; ***************************************************************************
PASS_SEL
	PSHS    A,B,X,Y
SEL_LOOP
	LDA     STATE_03
	CMPA    #$01
	BNE     MODE_20                 ; si no esta en modo PAGER, no ejecuto la rutina PASS_PAGER
	JSR     PASS_PAGER
MODE_20        
	LDB     #$01
	JSR     DTMF_TECLADO
	
	LDA     PRESSED_KEY
	CMPA    #$0F
	BEQ     CODE_1          ; si es "C" va a ejecutar a PASS_CONTROL
	
	LDB     STATE_00
	CMPB    #$00
	BEQ     DONT_WORK       ; si la RPT esta fuera de funcionamiento, entonces solo le doy bola al cambio de parametros

	CMPA    #$0D
	BEQ     CODE_2          ; si es "A" va a ejecutar a PASS_PATCH
	
	CMPA    STATE_16        
	BEQ     CODE_3          ; si es el codigo de la ID de la rpt, va a ejecutar a SAY_ID (siempre que STATE_15=1)
	
	CMPA    STATE_21        
	BEQ     CODE_4          ; si es el codigo del S-Meter Teller  va a ejecutar a S_TELLER (siempre que STATE_20=1)
DONT_WORK        
	LDA     STATE_RPT
	CMPA    #$01
	BEQ     MODE_20         ; si la rpt. no fue desactivada, siguo viendo si me piden hacer algo mas. por el contrario, si la rpt. se desactivo, voy a PASS_PAGER, para ver si cuando se vuelve a activar
	BRA     SEL_LOOP      
	
CODE_1
	JSR     PASS_CONTROL
	LDA     PRESSED_KEY
	CMPA    #$0B
	BEQ     MODE_20
	CMPA    #$0C
	BEQ     MODE_20                 ; si pone # o * comienzo todo de nuevo
	BRA     END_SEL                 ; si entro correctamente el codigo de acceso, sigo adelante, para que el usuario pueda cambiar los parametros

CODE_2
	LDA     STATE_05
	CMPA    #$01
	BNE     MODE_20                 ; si no esta permitido activar el patch salgo

	JSR     PASS_PATCH
	LDA     ABORT_MODE
	CMPA    #$0B
	BEQ     MODE_20
	CMPA    #$0C
	BEQ     MODE_20                 ; si pone # o * comienzo todo de nuevo
	
	LDA     PIA_2
	ORA     #$03                    ; indica que accione el patch y mantenga a la RPT en transmicion (en RPT Yaesu)
	STA     PIA_2                   ; si entro correctamente el codigo de acceso, acciono el PATCH

	LDA     #$01
	STA     PATCH                   ; aviso al resto del sistema que el patch esta activado
PATCH_LOOP        
	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     PRESSED_KEY
	CMPA    #$0C
	BEQ     MODE_21                 ; si oprimo # salgo del modo patch y lo desactivo
	
	LDA     STATE_03
	CMPA    #$01
	BNE     PATCH_LOOP              ; si no estoy en modo pager vuelvo a PATCH_LOOP a leer otro digito del DTMF

	LDA     STATE_RPT
	CMPA    #$01
	BEQ     PATCH_LOOP              ; si estoy en modo pager, pero no se desactivo la rpt. voy a PATCH_LOOP a leer otro digito del DTMF
	JSR     PASS_PAGER              ; si se desactivo la rpt. entonces voy a leer nuevamente el codigo del pager
	BRA     PATCH_LOOP
MODE_21
	LDA     PIA_2
	ANDA    #%11111100              ; indica que desaccione el patch
	STA     PIA_2                   ; desacciono el modo patch
	
	LDA     #$00
	STA     PATCH                   ; salgo del modo patch
	
	LDD     STATE_10
	STD     WAIT_TIME               ; reinicializo el timer
	LBRA    MODE_20                 ; luego comienzo todo de nuevo

CODE_3
	LDA     STATE_15
	CMPA    #$01
	LBNE    MODE_20
	JSR     SAY_ID
	LBRA    MODE_20

CODE_4
	LDA     STATE_20        
	CMPA    #$01
	LBNE    MODE_20
	JSR     S_TELLER
	LBRA    MODE_20
END_SEL
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; CHECKEA SI PASA EL CODIGO DE ACCESO.
; PASS_CONTROL()
; no requiere ningun parametro externo. compara el codigo entrado, con el 
; guardado en STATE_99. el control del uP no se queda en la rutina.
; si se ejecuta un # o * sale de la rutina, y luego PASS_SEL lo utiliza para
; no permitir el ingreso con el fin de cambiar datos.
; el fin de codigo esta determinado por un $0C en STATE_99.
; ***************************************************************************
PASS_CONTROL    
	PSHS    A,B,X,Y
PASS1_LOOP        
	LDY     #STATE_99
PASS_LOOP
	LDB     #$01
	JSR     DTMF_TECLADO
	
	LDA     PRESSED_KEY
	CMPA    #$0B
	BEQ     END_CONTROL
	CMPA    #$0C
	BEQ     END_CONTROL             ; si pone # o * salgo y por lo tanto vuelvo a PASS_SEL

	CMPA    ,Y
	BNE     PASS1_LOOP
	LEAY    1,Y
	
	LDA     ,Y
	CMPA    #$0C                    ; cuando aparece un "#" ($0C) quiere decir que termino el codigo de acceso        
	BNE     PASS_LOOP
END_CONTROL        
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; CHECKEA SI PASA EL CODIGO DEL PAGER.
; PASS_PAGER()
; no requiere ningun parametro externo. compara el codigo entrado, con el 
; guardado en STATE_04. el control del uP se queda en la rutina. solo sale
; cuando se ejecuta el codigo correcto. en tal caso se habilita la rpt. y se
; sale. si la rpt. esta en modo disable STATE_00=1, no la activa.
; el fin de codigo esta determinado por un $0C en STATE_04.
; ***************************************************************************
PASS_PAGER
	PSHS    A,B,X,Y
PASS1_PAGER        
	LDY     #STATE_04
PASS2_PAGER
	LDB     #$01
	JSR     DTMF_TECLADO
	
	LDA     PRESSED_KEY
	CMPA    #$0B
	BEQ     PASS1_PAGER
	CMPA    #$0C
	BEQ     PASS1_PAGER             ; si pone # o * salgo y por lo tanto vuelvo a PASS_SEL

	CMPA    ,Y
	BNE     PASS1_PAGER
	LEAY    1,Y
	
	LDA     ,Y
	CMPA    #$0C                    ; cuando aparece un "#" ($0C) quiere decir que termino el codigo de acceso        
	BNE     PASS2_PAGER
	
	LDA     STATE_00
	CMPA    #$01
	BNE     END_PAGER       ; si esta en modo disable STATE_00=1, no activa la rpt.

CHECK_END       ; checkeo que haya sesado el ultimo tono DTMF, antes de activar la rpt.
	LDA     PIA_0
	ANDA    #%00100000
	CMPA    #%00100000
	BEQ     CHECK_END       ; mientras el ulitmo tono no termine, sigo esperando

	LDA     PIA_0           ; activo momentariamente a la rpt. luego lo desactiva _IRQ, si se desactiva la rpt.
	ANDA    #%10111111      
	STA     PIA_0           
	
	LDA     #$01
	STA     STATE_RPT       ; me pongo en modo rpt. activate, ya que es la verdad y a mi no me gusta mentir!!! (ademas no lo puedo hacer despues, ya que en modo pager la rutina SAY_ID debe saber el estado de la rpt para parar la repro o no.
		
		; ---------------------- manejo STATE_14 en modo pager ------                                
	LDA     STATE_12
	CMPA    #$01
	BNE     NO1_SAY         ; si esta desactivado el phone-id, se calla la boca
	
	LDD     STATE_14
	CMPD    STATE_13        ;#$0000
	BEQ     NO1_SAY         ; si el valor es cero, debe quedar desactivado
	
	LDD     WAIT_TIME
	CMPD    STATE_14
	BHI     NO1_SAY
	JSR     SAY_ID          ; si se activa la rpt. despues de xxxx seg. la identifica, y luego comienza a contar el antiponcho 
NO1_SAY            
		; ------------------ fin manejo STATE_14 en modo pager ------                                
	
	LDD     STATE_10
	STD     WAIT_TIME       ; comienzo nuevamente a contar el timer del anti-poncho
END_PAGER        
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        
	
; ***************************************************************************
; RUTINA PARA SETEAR LA PIA EN BASE A LOS DATOS DE LAS VARIBLES STATE_xx.
; CHANGE_PIA()
; la rutina utiliza los parametros de las varibles STATE_xx para setear los
; 2 port's de la pia (PORT A y B).
; actualmente genera lo siguiente:
	* PB0 manejado por STATE_05 y por rutina PASS_SEL y PASS_PATCH (patch)
	* PB1 por ahora no se maneja [manejado por (tx_state)]
	* PB3 manejado por STATE_06 (user_1)
	* PB4 manejado por STATE_07 (user_2)
	* PB5 manejado por STATE_08 (user_3)
	
	* PA6 manejado por STATE_00 (tx_disable) (si el pager o el patch esta activado, entonces no lo toco)
	* PA7 lectura de estado de repetidora (no lo maneja esta rutina)
; ***************************************************************************
CHANGE_PIA
	PSHS    A,B,X,Y
	
	LDA     STATE_03
	CMPA    #$01
	BEQ     PAGER_ON        ; si el pager esta activado me voy a la mierda (pager_on)

	LDA     PATCH
	CMPA    #$01
	BEQ     PAGER_ON        ; si el patch esta activado me voy a la mierda (pager_on)

	LDA     STATE_00
	ASLA
	ASLA
	ASLA
	ASLA
	ASLA
	ASLA
	ANDA    #$40
	ADDA    #$40            ; equivale a un hex-inverter
	ANDA    #$40
	LDB     PIA_0
	ANDB    #%10111111
	STB     VAR_0
	ADDA    VAR_0
	STA     PIA_0           ; maneja el PA6 (enable/disable RPT TX)
	
PAGER_ON
	LDA     STATE_06
	ANDA    #$01
	ASLA
	ASLA
	ASLA
	LDB     STATE_07
	ANDB    #$01
	ASLB
	ASLB            ; chechear, (hay que correrlo hacia msb 1 bit)
	ASLB
	ASLB
	STB     VAR_0
	ADDA    VAR_0
	LDB     STATE_08
	ANDB    #$01
	ASLB
	ASLB
	ASLB            ; chechear, (hay que correrlo hacia msb 1 bit)
	ASLB
	ASLB
	STB     VAR_0        
	ADDA    VAR_0
	
	LDB     PIA_2
	ANDB    #%11000111
	STB     VAR_0
	ADDA    VAR_0
	STA     PIA_2           ; maneja los PB3, PB4, PB5 (USER 1-3 outputs)

	PULS    A,B,X,Y        
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA QUE MANEJA LA DESACT. DEL ANTI-PONCHO Y LA ACT. DEL ID
; TIME_OUT()
; esta rutina se basa en que cuando se activa la rpt. _IRQ pone en WAIT_TIME
; un numero de tiempo determinado, que luego mediante los interupts de 100Hz
; va disminuyendo hasta llegar a cero. cuando llega, y esta rutina checkea que
; el anti-poncho esta activado, y ademas la rpt. sigue activada, entonces la
; desactiva. la unica forma de reactivarla es mediante dejar de transmitir, y
; luego comenzar a transmitir nuevamente.
; si WAIT_TIME llega a cero, y la rpt. esta desactivada, entonces llama a 
; SAY_ID para que identifique a la rpt, luego carga el timer para que 
; comience a contar nuevamente.
; ***************************************************************************
TIME_OUT
	PSHS    A,B,X,Y
	; -------------------------------------------------------------------
	; Ver si cambio de estado (TX a QAP o viceversa) y accionar en base a ello
	LDA     PIA_0
	ANDA    #$80
	CMPA    BUFFER
	LBEQ    END_TIME
	STA     BUFFER
	
	CMPA    #$00
	BEQ     ID_CHECK        
	
	JSR     CHANGE_PIA      ; lo llamo para que si se desactivo la rpt por anti-poncho, ahora la reactive
	LDA     STATE_03
	CMPA    #$01
	LBEQ    END_TIME        ; si esta el pager activado, entonces se maneja todo desde PASS_PAGER, no desde aqui.
	
	LDA     PATCH
	CMPA    #$01
	BEQ     NO_SAY          ; si el patch esta andando, entonces no debe haber anti-poncho, etc

	LDA     STATE_12
	CMPA    #$01
	BNE     NO_SAY          ; si esta desactivado el phone-id, se calla la boca
	
	LDD     STATE_14
	CMPD    STATE_13        ;#$0000
	BEQ     NO_SAY          ; si el valor es cero, debe quedar desactivado
	
	LDD     WAIT_TIME
	CMPD    STATE_14
	BHI     NO_SAY
	JSR     SAY_ID          ; si se activa la rpt. despues de xxxx seg. la identifica, y luego comienza a contar el antiponcho 
NO_SAY            
	LDX     STATE_10        ; inicializo el tiempo del anti-ponchus
	STX     WAIT_TIME
	
	LDA     #$01
	STA     STATE_RPT
	LBRA    END_TIME


ID_CHECK
	LDA     STATE_25
	CMPA    #$00
	BEQ     CHECK_GOON      ; si esta desactivado el Instant Mode, sigo la rutina sin detenerme a analizar
	
	LDA     STATE_00
	CMPA    #$00
	BEQ     CHECK_GOON      ; si esta fuera de funcionamiento la RPT, entonces no debe funcionar el Instant Mode

	LDD     STATE_10
	SUBD    STATE_26
	CMPD    WAIT_TIME
	BHI     CHECK_GOON      ; si la rpt. estuvo encendida mas que el tiempo maximo de Instant Mode, sigue y no lo ejecuta

	LDD     STATE_10
	SUBD    STATE_27
	CMPD    WAIT_TIME
	BLS     CHECK_GOON      ; si el pulso de PTT no puede ser menor que state_27, no ejecuto Instant Mode (ya que indica que acabo de salir de reproducir algo, o que es un ruido muy corto, etc.)

	LDA     STATE_28
	CMPA    #$00
	BEQ     TYPE_0
			; ejecuto un SAY_ID
	JSR     SAY_ID
	BRA     CHECK_GOON
TYPE_0                  ; ejecuto un S_Teller
	JSR     S_TELLER
CHECK_GOON        
	LDX     WAIT_TIME
	LDD     STATE_22
	STD     WAIT_TIME
ID_TAIL        
	LDA     PIA_0
	ANDA    #$80
	CMPA    #$80
	BNE     TAIL_OUT        ; si se reactiva la rpt. dentro de este tiempo llamo a PONCH_CHECK, para que carge el timer y los datos correspondientes
	
	STX     WAIT_TIME       ; reestablezo el timer
	STA     BUFFER
	BRA     END_TIME
TAIL_OUT
	LDD     WAIT_TIME
	CMPD    #$0000
	BNE     ID_TAIL
	
	STX     WAIT_TIME       ; reestablezo el timer
	
	LDA     STATE_03
	CMPA    #$01
	BEQ     DIS             ; si no esta el pager activado, no desactivo la rpt.
	
	LDA     STATE_24
	CMPA    #$00
	BEQ     DIS             ; si la rpt. esta en modo "No Yaesu" (modo COR), entonces debe desactivar la RPT
	BRA     SEG_ID
DIS
	LDA     PATCH
	CMPA    #$01
	BEQ     SEG_ID          ; si el patch esta en uso, entonces no desactivo la RPT

	LDA     PIA_0
	ORA     #%01000000      
	STA     PIA_0           ; desactivo momentariamente a la RPT, luego CHANGE_PIA me lo reactiva (o no) al ir a START (quedo claro no?)
SEG_ID        
	LDA     STATE_RPT
	CMPA    #$00
	BEQ     END_TIME

	LDX     STATE_13        ; inicializo el tiempo del ID, siempre y cuando la STATE_RPT=1 , ya que sino no inicializo nuevamente el timer (esto se puede dar solamente en el modo pager, cuando desaprece una portadora que no mando el codigo del pager).
	STX     WAIT_TIME
	LDA     #$00
	STA     STATE_RPT
END_TIME        
	; -------------------------------------------------------------------
	

	LDD     WAIT_TIME
	CMPD    #$0000
	LBNE    END_TIME_OUT            ; si no es igual a cero, me voy ya que no debe ejecutar ni anti-poncho ni ID
		
	LDA     STATE_RPT
	CMPA    #$00
	BEQ     ID_OUT                  ; si se desactivo la rpt voy a ver si debo mandar el ID
	
	LDA     STATE_09
	CMPA    #$01
	BNE     END_TIME_OUT            ; checkeo si esta activado o no el anti-poncho
	
	LDA     STATE_00
	CMPA    #$01
	BNE     END_TIME_OUT            ; checkeo que la repetidora no este desactivada por un deseo del usuario

	LDA     PATCH
	CMPA    #$01
	BEQ     END_TIME_OUT            ; si esta el patch funcionando, etonces no debe funcionar el anti-poncho

	LDA     PIA_0
	ANDA    #$40
	CMPA    #$40
	BEQ     END_TIME_OUT            ; si ya estaba desactivada, es porque ya la desactive, por lo tanto no debo volver a desactivarla, ni volver a decir el mensaje de anti-poncho.
	
	LDA     PIA_0
	ORA     #%01000000              ; desactivo momentaneamente la rpt.
	STA     PIA_0
	
	LDA     STATE_11
	CMPA    #$01
	BNE     NO_PONCHO               ; si no esta activado el mensaje en phone de anti-poncho, me voy

	LDX     #AUD1_PONCHO
	LDD     #AUD2_PONCHO
	STD     OFS_TABLA
	ORCC    #ENMASK_IRQ             ; deshabilito las interrupciones, ya que sino aletrarian la ecualizacion de la rutina
	JSR     REPRO                   ; aviso en "Phone" (guarda que concheto!) que se apaga la repe y a joderse por boludo
	ANDCC   #ENABLE_IRQ             ; habilito nuevamente las interrupciones
	
	LDA     PIA_0
	ORA     #$40
	STA     PIA_0
BUG        
	LDA     PIA_0
	ANDA    #$80
	CMPA    #$00
	BNE     BUG

NO_PONCHO        
	BRA     END_TIME_OUT


ID_OUT
	LDA     PATCH
	CMPA    #$01
	BEQ     END_TIME_OUT            ; si esta funcionando el patch, entonces no debe andar el ID de la RPT
	
	LDA     STATE_12
	CMPA    #$01
	BNE     END_TIME_OUT            ; checkeo si esta activado o no el anti-poncho
	JSR     SAY_ID                  ; ejecuto la identificacion
	
	LDA     STATE_24
	CMPA    #$01
	BEQ     TX_OFF
	
	LDA     PIA_0
	ORA     #$40
	STA     PIA_0
TX_OFF        
	LDD     STATE_13
	STD     WAIT_TIME               ; cargo el tiempo para la proxima ID

END_TIME_OUT
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        
	
; ***************************************************************************
; RUTINA DE REPRODUCION DE AUDIO DIGITAL A 31,982642 KBIT/SEG
; REPRO()
; a esta rutina solo hay que pasarle desde donde y hasta donde debe
; reroducir. esto se logra mediante la introduccion en "X" de el 
; offset del address de comienzo de reproducion y en OFS_TABLA se
; introduce el offset del address de finalizacion.
; internamente la rutina esta ecualizada para que no importa los diferentes
; branch's que haga, su longitud entre bit y bit sera siempre de 28 ciclos de
; clock del micro (el mismo es la freq. del cristal, 3,582056, dividida 
; por 4, multiplicada por 28 ciclos, nos da los aprox. 32KBit/seg).
; para que la rpt. no se desactive mientras esta reproduciendo, la fuerzo
; activada mediante poner PB1=1 y PA6=0. al terminar de reproducir, paso a PB1
; a cero y PA6 lo dejo como estaba (previamente grabe el valor inicial en 
; VAR_0.
; ***************************************************************************
REPRO
	PSHS    A,B,X,Y
	
	LDA     PIA_0
	ANDA    #$40
	STA     VAR_0           ; lo guardo para luego actualizarlo

	LDA     PIA_0
	ANDA    #%10111111
	STA     PIA_0           ; mantengo activada a la rpt (en modo COR y Yaesu)

	LDA     PIA_2
	ORA     #%00000010
	STA     PIA_2           ; mantengo la rpt activada (en modo Yaesu)

	LDA     #$00
	LDY     #$6000
LOOP_REPRO
	STA     ,X              ; 4 ciclos
	ORCC    #$00            ; 3 ciclos
	STA     ,Y              ; 4 ciclos

	ADDA    #$08            ; 2 ciclos
	BNE     MODE_99         ; 3 ciclos
	LEAX    1,X             ; 5 ciclos
	
	ADDB    #$00            ; 2 ciclos
	ADDB    #$00            ; 2 ciclos
	BRA     LOOP_REPRO      ; 3 ciclos
MODE_99
	ADDB    #$00            ; 2 ciclos
	
	CMPX    OFS_TABLA       ; 7 ciclos
;        BNE     LOOP_REPRO      ; 3 ciclos
	BLS     LOOP_REPRO      ; 3 ciclos

	LDA     PIA_0
	ANDA    #%10111111
	ADDA    VAR_0
	STA     PIA_0           ; saco la mantenida de rpt activada
	
	LDA     PIA_2
	ANDA    #%11111101
	STA     VAR_0
	LDA     PATCH           ; si el patch esta funcionando, entonces mantengo a PB1=1 (para que se quede la RPT en TX)
	ROLA
	ANDA    #$02
	ADDA    VAR_0
	STA     PIA_2           ; saco la mantenida de rpt activada

	PULS   A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE GRABACION DE AUDIO DIGITAL A 31,982642 KBIT/SEG
; GRABA()
; a esta rutina solo hay que pasarle desde donde y hasta donde debe
; grabar. esto se logra mediante la introduccion en "X" de el 
; offset del address de comienzo de grabacion y en OFS_TABLA se
; introduce el offset del address de finalizacion.
; internamente la rutina esta ecualizada para que no importa los diferentes
; branch's que haga, su longitud entre bit y bit sera siempre de 28 ciclos de
; clock del micro (el mismo es la freq. del cristal, 3,582056, dividida 
; por 4, multiplicada por 28 ciclos, nos da los aprox. 32KBit/seg).
; ***************************************************************************
GRABA
	PSHS    A,B,X,Y
	
	ORCC    #ENMASK_IRQ      ; deshabilito las interrupciones, ya que sino aletrarian la ecualizacion de la rutina
	
	LDA     #$00
	LDB     #$08
	LDY     #$6000
LOOP_GRABA
	STA     ,X              ; 4 ciclos
	ORCC    #$00            ; 3 ciclos
	STB     ,Y              ; 4 ciclos

	ADDA    #$08            ; 2 ciclos
	BNE     MODE_98         ; 3 ciclos
	LEAX    1,X             ; 5 ciclos
	
	ADDB    #$00            ; 2 ciclos
	ADDB    #$08            ; 2 ciclos
	BRA     LOOP_GRABA      ; 3 ciclos
MODE_98
	ADDB    #$08            ; 2 ciclos
	
	CMPX    OFS_TABLA       ; 7 ciclos
	BNE     LOOP_GRABA      ; 3 ciclos

	ANDCC   #ENABLE_IRQ     ; habilito nuevamente las interrupciones
	
	PULS   A,B,X,Y
	RTS              
	; end ---------------------------------------------------------------        
	
; ***************************************************************************
; RUTINA QUE GENERA LA IDENTIFICACION EN PHONE DE LA RPT.
; SAY_ID()
; no requiere ningun parametro externo. el lugar a reproducir esta determinado
; por AUD1_ID y AUD2_ID. finalmente reproduce el ID de la rpt.
; ***************************************************************************
SAY_ID        
	PSHS    A,B,X,Y
	LDX     #AUD1_ID
	LDD     #AUD2_ID
	STD     OFS_TABLA
	
	LDA     PIA_1
	ANDA    #%11110111      ; seteo el control register A, para desactivar el IRQ de 100Hz
	STA     PIA_1

	LDA     STATE_03        
	CMPA    #$01
	BNE     JUST_REPRO      ; si no esta en modo pager, no tengo por que parar la reproduccion, por lo tanto voy derecho a reproducir

	LDA     STATE_RPT
	CMPA    #$01
	BEQ     JUST_REPRO      ; si la rpt. ya esta activada, entonces no tengo por que parar la reproduccion para checkear el codigo del pager (ya que el codigo ya fue checkeado anteriormente)

	LDA     PIA_2
	ORA     #%00000010
	STA     PIA_2

	LDA     PIA_2
	LDA     PIA_3
	ORA     #%00000011      ; hago que el cic9203 llame a interrupcion _IRQ, de modo que s mientras reproduce el ID, la rpt. se activa, entonces paro de reproducir el audio, para pasar a estar atento hacerca del codigo de pager entrado.
	STA     PIA_3
JUST_REPRO
	JSR     REPRO
	
	LDA     PIA_3
	ANDA    #%11111110      ; hago que el cic9203 no llame a interrupcion _IRQ
	STA     PIA_3
	
	LDA     PIA_0
	LDA     PIA_1
	ORA     #%00011100      ; seteo el control register A, para activar IRQ de 100Hz
	STA     PIA_1
	
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; CHECKEA SI PASA EL CODIGO DE ACCESO AL MODO PATCH.
; PASS_PATCH()
; no requiere ningun parametro externo. compara el codigo entrado, con el 
; guardado en STATE_98. el control del uP no se queda en la rutina.
; si se ejecuta un # o * sale de la rutina, y luego PASS_SEL lo utiliza para
; no permitir la activacion del Auto Patch.
; el fin de codigo esta determinado por un $0C en STATE_98.
; ***************************************************************************
PASS_PATCH        
	PSHS    A,B,X,Y
PASS1_PATCH
	LDY     #STATE_98
PASS2_PATCH
	LDB     #$01
	JSR     DTMF_TECLADO
	
	LDA     PRESSED_KEY
	CMPA    #$0B
	BEQ     END_PATCH
	CMPA    #$0C
	BEQ     END_PATCH               ; si pone # o * salgo y por lo tanto vuelvo a PASS_SEL

	CMPA    ,Y
	BNE     PASS1_PATCH
	LEAY    1,Y
	
	LDA     ,Y
	CMPA    #$0C                    ; cuando aparece un "#" ($0C) quiere decir que termino el codigo de acceso        
	BNE     PASS2_PATCH
END_PATCH
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE LECTURA DEL CONVERSOR A/D ADC0804.
; ADC_READ()
; la rutina lee del address ADC_ADRS, y el valor de la convercion lo 
; introduce en ADC_STATE.
; ***************************************************************************
ADC_READ
	PSHS    A,B,X,Y
	LDA     ADC_ADRS
	STA     ADC_STATE
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA QUE "PRONUNCIA" EL NIVEL DE SENAL CON EL CUAL SE ENTRA A LA RPT.
; S_TELLER()
; la rutina llama a ADC_READ, para que lea el valor del converson A/D, luego
; se encarga de decir el mensaje general a todos los S's y luego el especifico
; a cada uno.
; ***************************************************************************
S_TELLER
	PSHS    A,B,X,Y
	JSR     ADC_READ
	LDX     #AUD1_METER             
	LDD     #AUD2_METER
	STD     OFS_TABLA
	ORCC    #ENMASK_IRQ      ; deshabilito las interrupciones, ya que sino aletrarian la ecualizacion de la rutina
	JSR     REPRO           ; reproduzco la primera parte (comun a todos)        
	
	LDA     ADC_STATE
	CMPA    #31
	BLS     S1
	CMPA    #59
	BLS     S2
	CMPA    #87
	BLS     S3
	CMPA    #115
	BLS     S4
	CMPA    #143
	BLS     S5
	CMPA    #171
	BLS     S6
	CMPA    #199
	BLS     S7
	CMPA    #227
	BLS     S8
	BRA     S9
S1
	LDX     #AUD1_S1
	LDD     #AUD2_S1
	STD     OFS_TABLA
	JSR     REPRO
	BRA     END_TELLER
S2
	LDX     #AUD2_S1
	LDD     #AUD2_S2
	STD     OFS_TABLA
	JSR     REPRO
	BRA     END_TELLER
S3
	LDX     #AUD2_S2
	LDD     #AUD2_S3
	STD     OFS_TABLA
	JSR     REPRO
	BRA     END_TELLER
S4
	LDX     #AUD2_S3
	LDD     #AUD2_S4
	STD     OFS_TABLA
	JSR     REPRO
	BRA     END_TELLER
S5
	LDX     #AUD2_S4
	LDD     #AUD2_S5
	STD     OFS_TABLA
	JSR     REPRO
	BRA     END_TELLER
S6
	LDX     #AUD2_S5
	LDD     #AUD2_S6
	STD     OFS_TABLA
	JSR     REPRO
	BRA     END_TELLER
S7
	LDX     #AUD2_S6
	LDD     #AUD2_S7
	STD     OFS_TABLA
	JSR     REPRO
	BRA     END_TELLER
S8
	LDX     #AUD2_S7
	LDD     #AUD2_S8
	STD     OFS_TABLA
	JSR     REPRO
	BRA     END_TELLER
S9
	LDX     #AUD2_S8
	LDD     #AUD2_S9
	STD     OFS_TABLA
	JSR     REPRO
END_TELLER
	LDA     PIA_0           ; reseteo cualquier irq de cor que puede haber ocurrido
	ANDCC   #ENABLE_IRQ     ; habilito nuevamente las interrupciones
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA QUE CONVIERTE DE FORMATO DTMF A FORMATO HEXADECIMAL.        
; DTMF_HEX()
; la rutina lee los cuatro primeros bytes de PRESSED_KEY y mediante el empleo
; de la tabla CONV_DTMF_HEX se los conviete en un numero hexadecimal de dos
; bytes, que es introducido en los primeros dos bytes de PRESSED_KEY.
; los pasos de la convercion son los siguientes:
;
; (formato DTMF)------>B0(msb)  B1      B2      B3(lsb)
;                      I________I       I_______I
;                      II               II
;                      II               II
; (formato HEX)------->B0(msb)          B1(lsb)
;
; ***************************************************************************
DTMF_HEX        
	PSHS    A,B,X,Y

	LDX     #CONV_DTMF_HEX
	LDY     #PRESSED_KEY
	LDB     ,Y
	ABX        
	LDB     ,X
	ANDB    #$F0
	STB     ,Y

	LDX     #CONV_DTMF_HEX
	LEAY    1,Y
	LDB     ,Y
	ABX        
	LDB     ,X
	ANDB    #$0F
	STB     VAR_0
	LEAY    -1,Y
	LDA     ,Y
	ADDA    VAR_0
	STA     ,Y

	LDX     #CONV_DTMF_HEX          ; aqui comienza la convercion de los dos ultimos bytes
	LEAY    2,Y
	LDB     ,Y
	ABX        
	LDB     ,X
	ANDB    #$F0
	LEAY    -1,Y
	STB     ,Y

	LDX     #CONV_DTMF_HEX
	LEAY    2,Y
	LDB     ,Y
	ABX        
	LDB     ,X
	ANDB    #$0F
	STB     VAR_0
	LEAY    -2,Y
	LDA     ,Y
	ADDA    VAR_0
	STA     ,Y

	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA PARA PASAR LOS DIGITOS PROVENIENTES DEL CIC9203 A DECIMAL.
; CONVERT()
; lee el primer digito de PRESSED_KEY, y le pone un $00 si fuese $0A
; ***************************************************************************
CONVERT
	PSHS    A,B,X,Y
	LDA     PRESSED_KEY
	CMPA    #$0A
	BNE     MODE_4
	LDA     #$00
MODE_4
	STA     PRESSED_KEY
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        
	
; ***************************************************************************
; RUTINA DE VALIDACION DE SELECION.
; VALIDATE()
; esta rutina compara el valor en hex de "A", con el valor de los 2 primeros
; bytes de PRESSED_KEY, y da como salida un 0 en "B" si es igual o un 1 si es
; desigual.
; ademas compara si hay algun tipo de abort (si ABORT_MODE=$0B o 
; ABORT_MODE=$0C), si lo hay, no permite la ejecucion de las rutinas.
; esta rutina es utilizada por los SUB_xx para saber si deben actuar o no.
; ***************************************************************************
VALIDATE        
	PSHS    A,X,Y
	LDB     PRESSED_KEY
	CMPB    #$0B
	BEQ     NOT_SELECTED                
	CMPB    #$0C
	BEQ     NOT_SELECTED                
	
	LDB     #$00
	LDX     #PRESSED_KEY        
	STA     VAR_0
	ANDA    #$0F
	CMPA    ,X        
	BNE     NOT_SELECTED
	LEAX    1,X
	LDA     VAR_0
	RORA
	RORA
	RORA
	RORA    ; hay que correr un nibble a "A".
	ANDA    #$0F
	CMPA    ,X
	BEQ     END_VALIDATE
NOT_SELECTED                
	LDB     #$01
END_VALIDATE        
	PULS    A,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA QUE NO PERMITE QUE SE ACTIVEN DOS SUB_xx EN LA MISMA LECTURA.
; OUT()
; la rutina checkea si ABORT_MODE contiene un "*", si es asi, sale. pero si
; no, introduce en ABORT_MODE y en PRESSED_KEY, un "#", para que no se 
; ejecuten las demas rutinas.
; ***************************************************************************
OUT
	PSHS    A,B,X,Y
	LDA     ABORT_MODE
	CMPA    #$0B
	BEQ     END_OUT         ; si ya ha pedido el usuario salir, entonces no hago nada
	
	LDA     #$0C
	STA     PRESSED_KEY
	STA     ABORT_MODE
END_OUT        
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_00 (enable/disable rpt)
; SUB_00()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas (1/0), lo introduce en STATE_00 y inicializa el timer
; del Anti-Poncho.
; ***************************************************************************
SUB_00        
	PSHS    A,B,X,Y
	LDA     #$AA
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_00      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_00
	CMPA    #$0B
	BEQ     END_SUB_00

	JSR     CONVERT
	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$01
	BHI     END_SUB_00      ; checkeo que la variable este entre 0 y 1, sino me voy
	
	STA     STATE_00
	LDD     STATE_10
	STD     WAIT_TIME       ; inicializo el timer, por lo tanto si activo el Anti-Poncho luego de un timepo de que la RPT este activada, no la desactiva por Anti-Poncho
END_SUB_00
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_03 (enable/disable PAGE CODE RX)
; SUB_03()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas (1/0), lo introduce en STATE_03 y finalmente
; iniciacliza el timer de la RPT desactivada.
; ***************************************************************************
SUB_03
	PSHS    A,B,X,Y
	LDA     #$3A
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_03      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_03
	CMPA    #$0B
	BEQ     END_SUB_03

	JSR     CONVERT
	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$01
	BHI     END_SUB_03      ; checkeo que la variable este entre 0 y 1, sino me voy
	
	STA     STATE_03
	LDD     STATE_13
	STD     WAIT_TIME       ; inicializo el timer de RPT en modo disable (ya que al salir del modo chang values el usuario debe mandar el codio del pager para activar la RPT)
END_SUB_03
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DEL CAMBIO DE CODIGO DE ACCESO DEL PAGER.
; SUB_04()
; la rutina no requiere parametros externos. pone el nuevo codigo de acceso
; provisoriamente en STATE_99_BIS, y luego de validar la informacion, la 
; introduce en STATE_04 (si la validacion da algun error, se sale de la 
; rutina sin cambiar el codigo del patch (queda STATE_04 como estaba).
; la forma de cambiar el codigo de acesso, es la siguiente:
;
;      (codigo nuevo) + "#" + (codigo nuevo) + "#"
;
; de esta manera se entra y valida el nuevo codigo, cualquier alteracion hara
; que no se valide y por consiguiente no se cambie el valor STATE_04.
; para abortar la operacion se puede perfectamente oprimir "*", con lo cual
; uno sale del modo de cambio de parametros y la repetidora continua 
; funcionando como estaba.
; el largo del codigo de acesso no puede ser mayor de 15 caracteres.
; ***************************************************************************
SUB_04
	PSHS    A,B,X,Y
	LDA     #$4A
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_04      ; checkeo si eligieron esta funcion o no

	LDX     #STATE_04
	STX     OFS_TABLA
	JSR     CODE_MANAGER
	JSR     OUT             ; para que no se active ninguna otra sub
END_SUB_04
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_05 (enable/disable Patch)
; SUB_05()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas (1/0), lo introduce en STATE_05.
; ***************************************************************************
SUB_05
	PSHS    A,B,X,Y
	LDA     #$5A
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_05      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_05
	CMPA    #$0B
	BEQ     END_SUB_05

	JSR     CONVERT
	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$01
	BHI     END_SUB_05      ; checkeo que la variable este entre 0 y 1, sino me voy
	
	STA     STATE_05
END_SUB_05
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_06 (enable/disable USER-1)
; SUB_06()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas (1/0), lo introduce en STATE_06.
; ***************************************************************************
SUB_06
	PSHS    A,B,X,Y
	LDA     #$6A
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_06      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_06
	CMPA    #$0B
	BEQ     END_SUB_06

	JSR     CONVERT
	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$01
	BHI     END_SUB_06      ; checkeo que la variable este entre 0 y 1, sino me voy
	
	STA     STATE_06
END_SUB_06
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_07 (enable/disable USER-2)
; SUB_07()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas (1/0), lo introduce en STATE_07.
; ***************************************************************************
SUB_07
	PSHS    A,B,X,Y
	LDA     #$7A
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_07      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_07
	CMPA    #$0B
	BEQ     END_SUB_07

	JSR     CONVERT
	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$01
	BHI     END_SUB_07      ; checkeo que la variable este entre 0 y 1, sino me voy
	
	STA     STATE_07
END_SUB_07
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_08 (enable/disable USER-3)
; SUB_08()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas (1/0), lo introduce en STATE_08.
; ***************************************************************************
SUB_08
	PSHS    A,B,X,Y
	LDA     #$8A
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_08      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_08
	CMPA    #$0B
	BEQ     END_SUB_08

	JSR     CONVERT
	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$01
	BHI     END_SUB_08      ; checkeo que la variable este entre 0 y 1, sino me voy
	
	STA     STATE_08
END_SUB_08
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_09 (enable/disable ANTI-PONCHUS)
; SUB_09()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas (1/0), lo introduce en STATE_09 y inicializa el timer.
; ***************************************************************************
SUB_09
	PSHS    A,B,X,Y
	LDA     #$9A
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_09      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_09
	CMPA    #$0B
	BEQ     END_SUB_09

	JSR     CONVERT
	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$01
	BHI     END_SUB_09      ; checkeo que la variable este entre 0 y 1, sino me voy
	
	STA     STATE_09
	LDD     STATE_10
	STD     WAIT_TIME       ; inicializo el timer, por lo tanto si activo el Anti-Poncho luego de un timepo de que la RPT este activada, no la desactiva por Anti-Poncho
END_SUB_09
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_10 (tiempo antes de producir el ANTI-PONCHUS)
; SUB_10()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 4 byte del cic9203, los convierte a hex, y los introduce en STATE_10,
; siempre y cuando sea mayor a 2 segs.
; ***************************************************************************
SUB_10
	PSHS    A,B,X,Y
	LDA     #$A1
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_10      ; checkeo si eligieron esta funcion o no

	LDB     #$04
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_10
	CMPA    #$0B
	BEQ     END_SUB_10
	
	JSR     DTMF_HEX        ; convierto a PRESSED_KEY de formato DTMF a formato HEX

	LDD     PRESSED_KEY
	CMPD    #0200
	BLO     END_SUB_10      ; no puede ser menor de 2 segs.
	CMPD    STATE_26
	BLS     END_SUB_10      ; debe ser mayor que STATE_26

	STD     STATE_10        ; guardo el valor convertido en STATE_10 
	STD     WAIT_TIME       ; inicializo el timer nuevamente
	JSR     OUT             ; para que no se active ninguna otra sub
END_SUB_10
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        
 
; ***************************************************************************
; RUTINA DE MANEJO DE STATE_11 (enable/disable ANTI-PONCHUS PHONE ID)
; SUB_11()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas (1/0), lo introduce en STATE_11.
; ***************************************************************************
SUB_11
	PSHS    A,B,X,Y
	LDA     #$11
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_11      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_11
	CMPA    #$0B
	BEQ     END_SUB_11

	JSR     CONVERT
	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$01
	BHI     END_SUB_11      ; checkeo que la variable este entre 0 y 1, sino me voy
	
	STA     STATE_11
END_SUB_11
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_12 (enable/disable auto PHONE ID utilities)
; SUB_12()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas (1/0), lo introduce en STATE_12.
; ***************************************************************************
SUB_12
	PSHS    A,B,X,Y
	LDA     #$21
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_12      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_12
	CMPA    #$0B
	BEQ     END_SUB_12

	JSR     CONVERT
	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$01
	BHI     END_SUB_12      ; checkeo que la variable este entre 0 y 1, sino me voy
	
	STA     STATE_12
END_SUB_12
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_13 (tiempo entre ID's con rpt. QAP)
; SUB_13()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 4 byte del cic9203, los convierte a hex, y los introduce en STATE_13,
; siempre y cuando el valor resultante sea mayor de 2s. luego regenera a 
; STATE_13 y lo compara, la forma de realizarlo es la siguiente:
;
;       (antes de adquirir el no. de STATE_13)
;          STATE_13 - STATE_14 = TIME (tiempo de ID al activar rpt.)
;
;
;       (una vez adquirido el no. STATE_13')               
;          STATE_13' - TIME = STATE_14
;
;
;       (comparo antes de grabar a STATE_13' en STATE_13)
;          if STATE_13' > TIME and STATE_13'> #0200 then STATE_13 = STATE_13'
;
; ***************************************************************************
SUB_13
	PSHS    A,B,X,Y
	LDA     #$31
	JSR     VALIDATE
	CMPB    #$01        
	LBEQ    END_SUB_13      ; checkeo si eligieron esta funcion o no
	
	LDD     STATE_13
	SUBD    STATE_14
	STD     OFS_TABLA       ; esto lo utilizo luego para regenerar a STATE_14
	
	LDB     #$04
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_13
	CMPA    #$0B
	BEQ     END_SUB_13

	JSR     DTMF_HEX        ; convierto a PRESSED_KEY de formato DTMF a formato HEX

	LDD     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPD    #0200
	BLO     END_SUB_13              ; no puede ser menor de 2 segs
	CMPD    OFS_TABLA               ; el tiempo entre ID's no puede ser  mayor que el tiempo de activar rpt. con ID (yo me entiendo)
	BLS     END_SUB_13              ; no puede ser menor o igual que STATE_14

	STD     STATE_13                ; guardo el valor convertido en STATE_13 
	SUBD    OFS_TABLA
	STD     STATE_14                ; regenero a STATE_14
END_SUB_13
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_14 (tiempo entre ID's al activar rpt)
; SUB_14()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 4 byte del cic9203, los convierte a hex, y los introduce en STATE_14,
; siempre y cuando TIME sea menor que STATE_13. la forma de realizarlo es la
; siguiente:
;        (TIME es el valor introducido por el usuario)
;               STATE_13 - TIME = STATE_14'
;
;
;        (comparo antes de grabar STATE_14')
;               if TIME < STATE_13 then STATE_14 = STATE_14'
;
; ***************************************************************************
SUB_14
	PSHS    A,B,X,Y
	LDA     #$41
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_14      ; checkeo si eligieron esta funcion o no

	LDB     #$04
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_14
	CMPA    #$0B
	BEQ     END_SUB_14

	JSR     DTMF_HEX        ; convierto a PRESSED_KEY de formato DTMF a formato HEX

	LDD     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPD    STATE_13
	BHS     END_SUB_14      ; no puede ser mayor o igual a STATE_13
	
	STD     OFS_TABLA
	LDD     STATE_13
	SUBD    OFS_TABLA
	STD     STATE_14        ; guardo el valor convertido en STATE_14 
END_SUB_14
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_15 (enable/disable DTMF PHONE ID)
; SUB_15()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas (1/0), lo introduce en STATE_15.
; ***************************************************************************
SUB_15
	PSHS    A,B,X,Y
	LDA     #$51
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_15      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_15
	CMPA    #$0B
	BEQ     END_SUB_15

	JSR     CONVERT
	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$01
	BHI     END_SUB_15      ; checkeo que la variable este entre 0 y 1, sino me voy
	
	STA     STATE_15
END_SUB_15
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_16 (DTMF code for ID, 1 digit)
; SUB_16()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas y no sea igual al valor de "A", "C","#" o "*" el valor 
; del DTMD S-Meter Teller (STATE_21), lo introduce en STATE_16.
; ***************************************************************************
SUB_16
	PSHS    A,B,X,Y
	LDA     #$61
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_16      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_16
	CMPA    #$0B
	BEQ     END_SUB_16

	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$0D    ; "A"
	BEQ     END_SUB_16      
	CMPA    #$0F    ; "C"
	BEQ     END_SUB_16      
	CMPA    STATE_21        ; checkea que no sea igual al S-Teller code
	BEQ     END_SUB_16      
		
			; si valida el dato, y no es igual a ningun otro codigo, lo graba
	STA     STATE_16
END_SUB_16
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_17 (Record only ID Message)
; SUB_17()
; si es llamada graba el audio del mensage del ID de la rpt. solamente. esto 
; es solo 8 seg. se activa cuando PA7 = 0.
; ***************************************************************************
SUB_17
	PSHS    A,B,X,Y
	LDA     #$71
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_17      ; checkeo si eligieron esta funcion o no

LOOP_17
	LDA     PIA_0
	ANDA    #$80
	CMPA    #$80
	BEQ     LOOP_17        ; espero que PA7 se ponga en 0 para comenzar la grabacion

	LDX     #AUD1_ID        ; si la eligieron, grabo solo el sector de 8 seg correspondiente al ID Message
	LDD     #AUD2_ID 
	STD     OFS_TABLA
	JSR     GRABA
	JSR     OUT             ; para que no se active ninguna otra sub
END_SUB_17
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_18 (Record)
; SUB_18()
; si es llamada graba todo el audio (los 24 seg.), se activa cuando PA7 = 0.
; ***************************************************************************
SUB_18
	PSHS    A,B,X,Y
	LDA     #$81
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_18      ; checkeo si eligieron esta funcion o no

LOOP_18
	LDA     PIA_0
	ANDA    #$80
	CMPA    #$80
	BEQ     LOOP_18        ; espero que PA7 se ponga en 0 para comenzar la grabacion

	LDX     #AUDIO          ; si la eligieron, grabo todo el audio
	LDD     #FIN_AUDIO
	STD     OFS_TABLA
	JSR     GRABA
	JSR     OUT             ; para que no se active ninguna otra sub
END_SUB_18
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_19 (Test Play-All)
; SUB_19()
; si es llamada reproduce todo el audio (los 24 seg.)
; ***************************************************************************
SUB_19
	PSHS    A,B,X,Y
	LDA     #$91
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_19      ; checkeo si eligieron esta funcion o no

	LDX     #AUDIO          ; si la eligieron, reproduzco todo el audio
	LDD     #FIN_AUDIO
	STD     OFS_TABLA
	JSR     REPRO
	JSR     OUT             ; para que no se active ninguna otra sub
END_SUB_19
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_20 (enable/disable S-METER Teller by DTMF)
; SUB_20()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas (1/0), lo introduce en STATE_20.
; ***************************************************************************
SUB_20
	PSHS    A,B,X,Y
	LDA     #$A2
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_20      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_20
	CMPA    #$0B
	BEQ     END_SUB_20

	JSR     CONVERT
	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$01
	BHI     END_SUB_20      ; checkeo que la variable este entre 0 y 1, sino me voy
	
	STA     STATE_20
END_SUB_20
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_21 (DTMF code for S-Meter Teller, 1 digit)
; SUB_21()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas y no sea igual al valor de "A", "C","#" o "*" el valor 
; del DTMD ID (STATE_16), lo introduce en STATE_21.
; ***************************************************************************
SUB_21
	PSHS    A,B,X,Y
	LDA     #$12
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_21      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_21
	CMPA    #$0B
	BEQ     END_SUB_21

	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$0D    ; "A"
	BEQ     END_SUB_21      
	CMPA    #$0F    ; "C"
	BEQ     END_SUB_21      
	CMPA    STATE_16        ; checkea que no sea igual al DTMF ID code
	BEQ     END_SUB_21      
		
			; si valida el dato, y no es igual a ningun otro codigo, lo graba
	STA     STATE_21
END_SUB_21
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_22 (tiempo del Squelch Tail)
; SUB_22()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 4 byte del cic9203, los convierte a hex, y los introduce en STATE_22.
; ***************************************************************************
SUB_22
	PSHS    A,B,X,Y
	LDA     #$22
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_22      ; checkeo si eligieron esta funcion o no

	LDB     #$04
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_22
	CMPA    #$0B
	BEQ     END_SUB_22

	JSR     DTMF_HEX        ; convierto a PRESSED_KEY de formato DTMF a formato HEX

	LDD     PRESSED_KEY
	STD     STATE_22        ; guardo el valor convertido en STATE_22 
	JSR     OUT             ; para que no se active ninguna otra sub
END_SUB_22
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE RESET WITH DEFAULT VALUES (boot-up rpt. with default values)
; SUB_23()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 4 bytes del cic9203 y comprobar que el valor entrado es de 6666 (por
; que se me canto el culo!!!) genera un boot-up with default values, llamando 
; a FULL_RESET.
; ***************************************************************************
SUB_23
	PSHS    A,B,X,Y
	LDA     #$32
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_23      ; checkeo si eligieron esta funcion o no

	LDB     #$04
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_23
	CMPA    #$0B
	BEQ     END_SUB_23

	LDX     #PRESSED_KEY
	LDD     ,X
	CMPD    #$0606
	BNE     END_SUB_23
	LEAX    2,X
	LDD     ,X
	CMPD    #$0606
	BNE     END_SUB_23

	JMP     FULL_RESET      ; si paso el codigo requerido, genera el boot-up with default values
END_SUB_23
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_24 (enable/disable rpt)
; SUB_24()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas (1/0), lo introduce en STATE_24.
; ***************************************************************************
SUB_24
	PSHS    A,B,X,Y
	LDA     #$42
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_24      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_24
	CMPA    #$0B
	BEQ     END_SUB_24

	JSR     CONVERT
	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$01
	BHI     END_SUB_24      ; checkeo que la variable este entre 0 y 1, sino me voy
	
	STA     STATE_24
END_SUB_24
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_25 (enable/disable Instant Mode)
; SUB_25()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas (1/0), lo introduce en STATE_25.
; ***************************************************************************
SUB_25
	PSHS    A,B,X,Y
	LDA     #$52
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_25      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_25
	CMPA    #$0B
	BEQ     END_SUB_25

	JSR     CONVERT
	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$01
	BHI     END_SUB_25      ; checkeo que la variable este entre 0 y 1, sino me voy
	
	STA     STATE_25
END_SUB_25
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_26 (Instant Mode max. PTT time)
; SUB_26()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 4 byte del cic9203 y convertirlos de formato DTMF a HEX, los introduce 
; en STATE_26.
; ***************************************************************************
SUB_26
	PSHS    A,B,X,Y
	LDA     #$62
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_26      ; checkeo si eligieron esta funcion o no

	LDB     #$04
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_26
	CMPA    #$0B
	BEQ     END_SUB_26

	JSR     DTMF_HEX        ; convierto de formato DTMF a formato HEX.

	LDD     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPD    #0004
	BLO     END_SUB_26      ; checkeo que la variable no sea menor que 4, sino me voy
	CMPD    STATE_10
	BHS     END_SUB_26      ; checkeo que la variable no sea mayor o igual al tiempo de antiponcho

	STA     STATE_26
END_SUB_26
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_27 (Instant Mode min. PTT time)
; SUB_27()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 4 byte del cic9203 y convertirlos de formato DTMF a HEX, los introduce 
; en STATE_27.
; ***************************************************************************
SUB_27
	PSHS    A,B,X,Y
	LDA     #$72
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_27      ; checkeo si eligieron esta funcion o no

	LDB     #$04
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_27
	CMPA    #$0B
	BEQ     END_SUB_27

	JSR     DTMF_HEX        ; convierto de formato DTMF a formato HEX.

	LDD     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPD    #0003
	BLO     END_SUB_27      ; checkeo que la variable no sea menor que 3, sino me voy
	CMPD    STATE_26
	BHS     END_SUB_27      ; checkeo que la variable no sea mayor o igual al tiempo max. de activacion del PTT

	STA     STATE_27
END_SUB_27
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DE STATE_28 (Instant Mode ID or S Teller enable)
; SUB_28()
; la rutina checkea primero si debe activarce (llendo a VALIDATE) y luego de
; leer 1 byte del cic9203 y comprobar que el valor entrado esta dentro de las 
; magnitudes correctas (1/0), lo introduce en STATE_28.
; ***************************************************************************
SUB_28
	PSHS    A,B,X,Y
	LDA     #$82
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_28      ; checkeo si eligieron esta funcion o no

	LDB     #$01
	JSR     DTMF_TECLADO
	LDA     ABORT_MODE
	CMPA    #$0C
	BEQ     END_SUB_28
	CMPA    #$0B
	BEQ     END_SUB_28

	JSR     CONVERT
	LDA     PRESSED_KEY
	JSR     OUT             ; para que no se active ninguna otra sub
	CMPA    #$01
	BHI     END_SUB_28      ; checkeo que la variable este entre 0 y 1, sino me voy
	
	STA     STATE_28
END_SUB_28
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DEL CAMBIO DE CODIGO DE ACCESO.
; SUB_98()
; la rutina no requiere parametros externos. pone el nuevo codigo de acceso
; provisoriamente en STATE_99_BIS, y luego de validar la informacion, la 
; introduce en STATE_98 (si la validacion da algun error, se sale de la 
; rutina sin cambiar el codigo del patch (queda STATE_98 como estaba).
; la forma de cambiar el codigo de acesso, es la siguiente:
;
;      (codigo nuevo) + "#" + (codigo nuevo) + "#"
;
; de esta manera se entra y valida el nuevo codigo, cualquier alteracion hara
; que no se valide y por consiguiente no se cambie el valor STATE_98.
; para abortar la operacion se puede perfectamente oprimir "*", con lo cual
; uno sale del modo de cambio de parametros y la repetidora continua 
; funcionando como estaba.
; el largo del codigo de acesso no puede ser mayor de 15 caracteres o menor
; de 1 caracter.
; ***************************************************************************
SUB_98
	PSHS    A,B,X,Y
	LDA     #$89
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_SUB_98      ; checkeo si eligieron esta funcion o no

	LDX     #STATE_98
	STX     OFS_TABLA
	JSR     CODE_MANAGER
	JSR     OUT             ; para que no se active ninguna otra sub
END_SUB_98
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DEL CAMBIO DE CODIGO DE ACCESO.
; SUB_99()
; la rutina no requiere parametros externos. pone el nuevo codigo de acceso
; provisoriamente en STATE_99_BIS, y luego de validar la informacion, la 
; introduce en STATE_99 (si la validacion da algun error, se sale de la 
; rutina sin cambiar el codigo de acesso (queda STATE_99 como estaba).
; la forma de cambiar el codigo de acesso, es la siguiente:
;
;      (codigo nuevo) + "#" + (codigo nuevo) + "#"
;
; de esta manera se entra y valida el nuevo codigo, cualquier alteracion hara
; que no se valide y por consiguiente no se cambie el valor STATE_99.
; para abortar la operacion se puede perfectamente oprimir "*", con lo cual
; uno sale del modo de cambio de parametros y la repetidora continua 
; funcionando como estaba.
; el largo del codigo de acesso no puede ser mayor de 15 caracteres o menor
; de 1 caracter.
; ***************************************************************************
SUB_99        
	PSHS    A,B,X,Y
	LDA     #$99
	JSR     VALIDATE
	CMPB    #$01        
	BEQ     END_99          ; checkeo si eligieron esta funcion o no

	LDX     #STATE_99
	STX     OFS_TABLA
	JSR     CODE_MANAGER
	JSR     OUT             ; para que no se active ninguna otra sub
END_99
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

; ***************************************************************************
; RUTINA DE MANEJO DEL CAMBIO DE CODIGO DE ACCESO.
; CODE_MANAGER()
; esta rutina le brinda el servicio a SUB_98 y a SUB_99. estas rutinas le
; ponen en OFS_TABLA el address de STATE_98 o STATE_99 respectivamente.
; el resto del funcionamiento esta explicado en cada una de las rutinas antes
; mencionadas.
; ***************************************************************************
CODE_MANAGER
	PSHS    A,B,X,Y
				; aqui verdaderamente comiena el prog.
	LDX     #STATE_99_BIS
	LDA     #$00
SUB_99_LOOP
	LDB     #$01
	JSR     DTMF_TECLADO
	LDB     PRESSED_KEY
	CMPB    #$0B
	BEQ     END_SUB_99              ; si oprime "*", entonces sale
	
	STB     ,X                      ; primero lo grabo, para que si se oprimio "#", el mismo quede en la variable
	
	CMPB    #$0C
	BEQ     CHECK_PASSWORD
	
	LEAX    1,X
	INCA
	CMPA    #17
	BNE     SUB_99_LOOP             ; si pasa los 15 caracteres, genera artificialmente un abort de tipo $0B ("*") de salida total
	
	LDA     #$0B
	STA     ABORT_MODE
	BRA     END_SUB_99
CHECK_PASSWORD          ; aqui checkeamos nuevamente el codigo de acesso
	LDY     #STATE_99_BIS
	LDA     ,Y
	CMPA    #$0C
	BNE     CHECK_LOOP_99           ; si el codigo es de 0 digitos de longitud realizo un abort (ya que el largo minimo es de 1 digito)

	LDA     #$0B
	STA     ABORT_MODE
	BRA     END_SUB_99
CHECK_LOOP_99
	LDB     #$01
	JSR     DTMF_TECLADO
	
	LDB     PRESSED_KEY
	CMPB    #$0B
	BEQ     END_SUB_99              ; si oprime "*", entonces sale

	LDA     PRESSED_KEY
	CMPA    ,Y
	BNE     END_SUB_99
	
	LDA     ,Y
	LEAY    1,Y
	CMPA    #$0C                    ; cuando aparece un "#" ($0C) quiere decir que termino el codigo de acceso        
	BNE     CHECK_LOOP_99     
			; si logra pasar el checkeo, entonces lo copia en STATE_99
	LDX     #STATE_99_BIS
	LDY     OFS_TABLA
	LDB     #16
	JSR     STRINGCOPY              ; ya estoy seguro de que el nuevo codigo esta correcto, por lo tanto lo introduzco en STATE_99
END_SUB_99        
	PULS    A,B,X,Y
	RTS
	; end ---------------------------------------------------------------        

	END
